*** a/src/backend/access/transam/xact.c
--- b/src/backend/access/transam/xact.c
***************
*** 4608,4613 **** BlockStateAsString(TBlockState blockState)
--- 4914,4931 ----
  			return "SUB RESTART";
  		case TBLOCK_SUBABORT_RESTART:
  			return "SUB AB RESTRT";
+ 		case TBLOCK_AUTOINPROGRESS:
+ 			return "AUTO INPROGRESS";
+ 		case TBLOCK_AUTOBEGIN:
+ 			return "AUTO BEGIN";
+ 		case TBLOCK_AUTOCOMMIT:
+ 			return "AUTO COMMIT";
+ 		case TBLOCK_AUTOABORT:
+ 			return "AUTO ABORT";
+ 		case TBLOCK_AUTOABORT_END:
+ 			return "AUTO ABORT END";
+ 		case TBLOCK_AUTOABORT_PENDING:
+ 			return "AUTO ABORT PENDING";
  	}
  	return "UNRECOGNIZED";
  }
***************
*** 4980,4982 **** xact_redo(XLogRecPtr lsn, XLogRecord *record)
--- 5298,5858 ----
  	else
  		elog(PANIC, "xact_redo: unknown op code %u", info);
  }
+ 
+ 
+ void
+ DefineAutonomousTransaction(void)
+ {
+ 	TransactionState s = CurrentTransactionState;
+ 
+ 	if (MyProc->inAutoTXLevel >= MAX_AUTOX_NESTING_LEVEL)
+ 		ereport(ERROR,
+ 				(errmsg("Has reach the max autonomous nesting level.")));
+ 	switch (s->blockState)
+ 	{
+ 		case TBLOCK_INPROGRESS:
+ 		case TBLOCK_SUBINPROGRESS:
+ 		case TBLOCK_STARTED:
+ 		case TBLOCK_AUTOINPROGRESS:
+ 			/* Normal subtransaction start */
+ 			PushTransaction(true);
+ 			break;
+ 
+ 			/* These cases are invalid. */
+ 
+ 		default:
+ 			ereport(FATAL,
+ 				(errmsg("DefineAutonomousTransaction: unexpected state %s",
+ 						BlockStateAsString(s->blockState))));
+ 			break;
+ 	}
+ }
+ 
+ void
+ BeginAutonomousTransaction(void)
+ {
+ 	TransactionState s = CurrentTransactionState;
+ 
+ 	if (s->state != TRANS_DEFAULT)
+ 		ereport(WARNING,
+ 				(errmsg("BeginAutonomousTransaction while in %s state",
+ 			 	TransStateAsString(s->state))));
+ 
+ 	s->state = TRANS_START;
+ 
+ 	/*
+ 	 * Initialize subsystems for new subtransaction
+ 	 *
+ 	 * must initialize resource-management stuff first
+ 	 */
+ 	AtSubStart_Memory();
+ 	AtSubStart_ResourceOwner();
+ 	AtSubStart_Inval();
+ 	AtSubStart_Notify();
+ 	AfterTriggerBeginSubXact();
+ 
+ 	s->state = TRANS_INPROGRESS;
+ 
+ 	/*
+ 	 * Call start-of-subxact callbacks
+ 	 */
+ 	CallSubXactCallbacks(SUBXACT_EVENT_START_SUB, s->subTransactionId,
+ 						 s->parent->subTransactionId);
+ 
+ 	ShowTransactionState("BeginAutonomousTransaction");
+ }
+ 
+ void
+ CommitAutonomousTransaction(void)
+ {
+ 	TransactionState s = CurrentTransactionState;
+ 	TransactionId latestXid;
+ 	ShowTransactionState("CommitAutonomousTransaction");
+ 
+ 	if (s->state != TRANS_INPROGRESS)
+ 		ereport(WARNING,
+ 				(errmsg("CommitAutonomousTransaction while in %s state",
+ 				 TransStateAsString(s->state))));
+ 
+ 	/*
+ 	 * Prior to 8.4 we marked subcommit in clog at this point.	We now only
+ 	 * perform that step, if required, as part of the atomic update of the
+ 	 * whole transaction tree at top level commit or abort.
+ 	 */
+ 	for (;;)
+ 	{
+ 		/*
+ 		 * Fire all currently pending deferred triggers.
+ 		 */
+ 		AfterTriggerFireDeferredForAutoX();
+ 
+ 		/*
+ 		 * Close open portals (converting holdable ones into static portals).
+ 		 * If there weren't any, we are done ... otherwise loop back to check
+ 		 * if they queued deferred triggers.  Lather, rinse, repeat.
+ 		 */
+ 		if (!AutoPreCommit_Portals(s->subTransactionId))
+ 			break;
+ 	}
+ 
+ 
+ 
+ 	AfterTriggerEndSubXact(false);
+ 
+ 	AtSubCommit_Portals(s->subTransactionId,
+ 						s->parent->subTransactionId,
+ 						s->parent->curTransactionOwner);
+ 
+ 	PreCommit_on_commit_actions();
+ 	AtEOSubXact_LargeObject(false, s->subTransactionId,
+ 							s->parent->subTransactionId);
+ 	AtSubAbort_Notify();
+ 
+ 	/* Prevent cancel/die interrupt while cleaning up */
+ 	HOLD_INTERRUPTS();
+ 
+ 	s->state = TRANS_COMMIT;
+ 	/* Advertise the fact that we aborted in pg_clog. */
+ 	latestXid = RecordTransactionCommit(true);
+ 	ProcArrayEndAutonomousTransaction(MyProc, latestXid);
+ 	/* Post-commit cleanup */
+ 	if (TransactionIdIsValid(s->transactionId))
+ 		AtSubAbort_childXids();
+ 
+ 	CallSubXactCallbacks(SUBXACT_EVENT_COMMIT_SUB, s->subTransactionId,
+ 						 s->parent->subTransactionId);
+ 
+ 	ResourceOwnerRelease(s->curTransactionOwner,
+ 						 RESOURCE_RELEASE_BEFORE_LOCKS,
+ 						 false, false);
+ 	AtEOSubXact_RelationCache(false, s->subTransactionId,
+ 							  s->parent->subTransactionId);
+ 	AtEOAutoXact_Inval(true);
+ 	smgrDoPendingDeletes(true);
+ 	/*
+ 	 * The only lock we actually release here is the subtransaction XID lock.
+ 	 */
+ 	CurrentResourceOwner = s->curTransactionOwner;
+ 	if (TransactionIdIsValid(s->transactionId))
+ 		XactLockTableDelete(s->transactionId);
+ 
+ 	/*
+ 	 * Other locks should get transferred to their parent resource owner.
+ 	 */
+ 	ResourceOwnerRelease(s->curTransactionOwner,
+ 						 RESOURCE_RELEASE_LOCKS,
+ 						 false, false);
+ 	ResourceOwnerRelease(s->curTransactionOwner,
+ 						 RESOURCE_RELEASE_AFTER_LOCKS,
+ 						 false, false);
+ 
+ 	AtEOXact_GUC(true, s->gucNestLevel);
+ 	AtEOSubXact_SPI(true, s->subTransactionId);
+ 	AtEOSubXact_on_commit_actions(false, s->subTransactionId,
+ 								  s->parent->subTransactionId);
+ 	AtEOAutoXact_Namespace(true, s->subTransactionId,
+ 						  s->parent->subTransactionId);
+ 	AtEOSubXact_Files(false, s->subTransactionId,
+ 					  s->parent->subTransactionId);
+ 	AtEOSubXact_HashTables(true, s->nestingLevel);
+ 	AtEOSubXact_PgStat(false, s->nestingLevel);
+ 	AtSubAbort_Snapshot(s->nestingLevel);
+ 
+ 	/*
+ 	 * We need to restore the upper transaction's read-only state, in case the
+ 	 * upper is read-write while the child is read-only; GUC will incorrectly
+ 	 * think it should leave the child state in place.
+ 	 */
+ 	XactReadOnly = s->prevXactReadOnly;
+ 	CleanupSubTransaction();
+ 
+ 	RESUME_INTERRUPTS();
+ }
+ 
+ void
+ AbortAutonomousTransaction(void)
+ {
+ 	TransactionState s = CurrentTransactionState;
+ 	TransactionId latestXid;
+ 
+ 	/* Prevent cancel/die interrupt while cleaning up */
+ 	HOLD_INTERRUPTS();
+ 
+ 	/* Make sure we have a valid memory context and resource owner */
+ 	AtSubAbort_Memory();
+ 	AtSubAbort_ResourceOwner();
+ 
+ 	/*
+ 	 * Release any LW locks we might be holding as quickly as possible.
+ 	 * (Regular locks, however, must be held till we finish aborting.)
+ 	 * Releasing LW locks is critical since we might try to grab them again
+ 	 * while cleaning up!
+ 	 *
+ 	 * FIXME This may be incorrect --- Are there some locks we should keep?
+ 	 * Buffer locks, for example?  I don't think so but I'm not sure.
+ 	 */
+ 	LWLockReleaseAll();
+ 
+ 	AbortBufferIO();
+ 	UnlockBuffers();
+ 
+ 	LockErrorCleanup();
+ 
+ 	/*
+ 	 * check the current transaction state
+ 	 */
+ 	ShowTransactionState("AbortInternalAutonomousTransaction");
+ 
+ 	if (s->state != TRANS_INPROGRESS)
+ 		ereport(WARNING,
+ 				(errmsg("AbortInternalAutonomousTransaction while in %s state",
+ 			 	TransStateAsString(s->state))));
+ 	s->state = TRANS_ABORT;
+ 
+ 	/*
+ 	 * Reset user ID which might have been changed transiently.  (See notes in
+ 	 * AbortTransaction.)
+ 	 */
+ 	SetUserIdAndSecContext(s->prevUser, s->prevSecContext);
+ 
+ 	/*
+ 	 * We can skip all this stuff if the subxact failed before creating a
+ 	 * ResourceOwner...
+ 	 */
+ 	if (s->curTransactionOwner)
+ 	{
+ 		AfterTriggerEndSubXact(false);
+ 		AtSubAbort_Portals(s->subTransactionId,
+ 						   s->parent->subTransactionId,
+ 						   s->parent->curTransactionOwner);
+ 		AtEOSubXact_LargeObject(false, s->subTransactionId,
+ 								s->parent->subTransactionId);
+ 		AtSubAbort_Notify();
+ 
+ 		/* Advertise the fact that we aborted in pg_clog. */
+ 		latestXid = RecordTransactionAbort(true);
+ 		ProcArrayEndAutonomousTransaction(MyProc, latestXid);
+ 		/* Post-abort cleanup */
+ 		if (TransactionIdIsValid(s->transactionId))
+ 			AtSubAbort_childXids();
+ 
+ 		CallSubXactCallbacks(SUBXACT_EVENT_ABORT_SUB, s->subTransactionId,
+ 							 s->parent->subTransactionId);
+ 
+ 		ResourceOwnerRelease(s->curTransactionOwner,
+ 							 RESOURCE_RELEASE_BEFORE_LOCKS,
+ 							 false, false);
+ 		AtEOSubXact_RelationCache(false, s->subTransactionId,
+ 								  s->parent->subTransactionId);
+ 		AtEOAutoXact_Inval(false);
+ 		AtSubAbort_smgr();
+ 		ResourceOwnerRelease(s->curTransactionOwner,
+ 							 RESOURCE_RELEASE_LOCKS,
+ 							 false, false);
+ 		ResourceOwnerRelease(s->curTransactionOwner,
+ 							 RESOURCE_RELEASE_AFTER_LOCKS,
+ 							 false, false);
+ 
+ 		AtEOXact_GUC(false, s->gucNestLevel);
+ 		AtEOSubXact_SPI(true, s->subTransactionId);
+ 		AtEOSubXact_on_commit_actions(false, s->subTransactionId,
+ 									  s->parent->subTransactionId);
+ 		AtEOAutoXact_Namespace(false, s->subTransactionId,
+ 							  s->parent->subTransactionId);
+ 		AtEOSubXact_Files(false, s->subTransactionId,
+ 						  s->parent->subTransactionId);
+ 		AtEOSubXact_HashTables(false, s->nestingLevel);
+ 		AtEOSubXact_PgStat(false, s->nestingLevel);
+ 		AtSubAbort_Snapshot(s->nestingLevel);
+ 	}
+ 
+ 	/*
+ 	 * Restore the upper transaction's read-only state, too.  This should be
+ 	 * redundant with GUC's cleanup but we may as well do it for consistency
+ 	 * with the commit case.
+ 	 */
+ 	XactReadOnly = s->prevXactReadOnly;
+ 
+ 	RESUME_INTERRUPTS();
+ }
+ 
+ /*
+  * Brief: PLpgSQL_SetPreContextAndResource
+  * save the previous memory context and resource owner
+  * Param: preContext
+  * Param: preOwner
+  */
+ void
+ PLpgSQL_SetPreContextAndResource(MemoryContext preContext,ResourceOwner preOwner)
+ {
+ 	TransactionState s = CurrentTransactionState;
+ 
+ 	if (s)
+ 	{
+ 		s->preMemoryContext = preContext;
+ 		s->preResourceOwner = preOwner;
+ 	}
+ }
+ 
+ /*
+  * Brief: PLpgSQL_GetPreContextAndResource
+  * get  the previous memory context and resource owner
+  * Param: preContext
+  * Param: preOwner
+  */
+ static void
+ PLpgSQL_GetPreContextAndResource(MemoryContext *preContext,ResourceOwner *preOwner)
+ {
+ 	TransactionState s = CurrentTransactionState;
+ 
+ 	if (s)
+ 	{
+ 		*preContext = s->preMemoryContext;
+ 		*preOwner = s->preResourceOwner;
+ 	}
+ 	else
+ 	{
+ 		*preContext = NULL;
+ 		*preOwner = NULL;
+ 	}
+ }
+ 
+ /*****************************************************************************
+   Description    : BeginInternalAutonomousTransaction()
+   				   CommitInternalAutonomousTransaction()
+   				   AbortInternalAutonomousTransaction()
+   				   There fuctions are used to manage a internal autonomous
+   				   transaction.
+   Input          :
+   Output         :
+   Return Value   : void
+   Notes          : when use autonomous transaction internal, you should use
+   				   those functions with a block around PG_TRY()PG_CATCH()
+ 				   example:
+ 					BeginInternalAutonomousTransaction();
+ 					PG_TRY();
+ 					{
+ 						...
+ 						CommitInternalAutonomousTransaction();
+ 					}
+ 					PG_CATCH();
+ 					{
+ 						...
+ 
+ 						*Notice:
+ 						*if use PG_RE_THROW() to throw the error to the next outer
+ 						*setjmp handler, we shouldn't  call EmitErrorReport()and
+ 						*FlushErrorState().
+ 
+ 						EmitErrorReport();
+ 
+ 						AbortInternalAutonomousTransaction();
+ 
+ 						FlushErrorState();
+ 						...
+ 						*PG_RE_THROW();*
+ 					}
+ 					PG_END_TRY();
+   History        :
+ 	Modification :
+ *****************************************************************************/
+ void
+ BeginInternalAutonomousTransaction(void)
+ {
+ 	TransactionState s = CurrentTransactionState;
+ 	MemoryContext oldContext = CurrentMemoryContext;
+ 	ResourceOwner oldOwner = CurrentResourceOwner;
+ 
+ 	switch (s->blockState)
+ 	{
+ 		case TBLOCK_STARTED:
+ 		case TBLOCK_INPROGRESS:
+ 		case TBLOCK_SUBINPROGRESS:
+ 		case TBLOCK_AUTOINPROGRESS:
+ 			/* Normal subtransaction start */
+ 			PushTransaction(true);
+ 			break;
+ 
+ 			/* These cases are invalid. */
+ 
+ 		default:
+ 			ereport(FATAL,
+ 					(errmsg("DefineAutonomousTransaction: unexpected state %s",
+ 				 BlockStateAsString(s->blockState))));
+ 			break;
+ 	}
+ 	CommitTransactionCommand();
+ 	StartTransactionCommand();
+ 	PLpgSQL_SetPreContextAndResource(oldContext, oldOwner);
+ 	(void)MemoryContextSwitchTo(oldContext);
+ }
+ 
+ /*****************************************************************************
+   Description    : When commit the autonomous transaction, it would not transfer
+   				   resources taken previously to its parent transaction, but
+   				   release all of them.
+   Input          :
+   Output         :
+   Return Value   : TransactionId
+   Notes          :
+   History        :
+ 	Modification :
+ *****************************************************************************/
+ void
+ CommitInternalAutonomousTransaction(void)
+ {
+ 	TransactionState s = NULL;
+ 	MemoryContext	preContext  = NULL;
+ 	ResourceOwner	preOwner    = NULL;
+ 	s = CurrentTransactionState;
+ 	PLpgSQL_GetPreContextAndResource(&preContext,&preOwner);
+ 
+ 	switch (s->blockState)
+ 	{
+ 		/*
+ 		 * We are in a live subtransaction block.  Set up to subcommit all
+ 		 * open subtransactions and then commit the main transaction.
+ 		 */
+ 		case TBLOCK_SUBINPROGRESS:
+ 			while (s->parent != NULL && !IS_TOP_AUTO_TX_STATE(s))
+ 			{
+ 				if (s->blockState == TBLOCK_SUBINPROGRESS)
+ 					s->blockState = TBLOCK_SUBCOMMIT;
+ 				else
+ 					ereport(FATAL,
+ 						(errmsg("EndAutonomousTransactionBlock: unexpected state %s",
+ 						 BlockStateAsString(s->blockState))));
+ 				s = s->parent;
+ 			}
+ 			if(s->blockState == TBLOCK_AUTOINPROGRESS)
+ 				s->blockState = TBLOCK_AUTOCOMMIT;
+ 			else
+ 				ereport(FATAL,
+ 					(errmsg("EndAutonomousTransactionBlock: unexpected state %s",
+ 					 BlockStateAsString(s->blockState))));
+ 			break;
+ 
+ 			/*
+ 			 * Here we are inside an aborted subtransaction.  Treat the COMMIT
+ 			 * as ROLLBACK: set up to abort everything and exit the main
+ 			 * transaction.
+ 			 */
+ 		case TBLOCK_SUBABORT:
+ 			while (s->parent != NULL && !IS_TOP_AUTO_TX_STATE(s))
+ 			{
+ 				if (s->blockState == TBLOCK_SUBINPROGRESS)
+ 					s->blockState = TBLOCK_SUBABORT_PENDING;
+ 				else if (s->blockState == TBLOCK_SUBABORT)
+ 					s->blockState = TBLOCK_SUBABORT_END;
+ 				else
+ 					ereport(FATAL,
+ 						(errmsg("EndAutonomousTransactionBlock: unexpected state %s",
+ 						 BlockStateAsString(s->blockState))));
+ 				s = s->parent;
+ 			}
+ 			if(s->blockState == TBLOCK_AUTOINPROGRESS)
+ 				s->blockState = TBLOCK_AUTOABORT_PENDING;
+ 			else if(s->blockState == TBLOCK_AUTOABORT)
+ 				s->blockState = TBLOCK_AUTOABORT_END;
+ 			else
+ 				ereport(FATAL,
+ 					(errmsg("EndAutonomousTransactionBlock: unexpected state %s",
+ 					 BlockStateAsString(s->blockState))));
+ 			break;
+ 
+ 		case TBLOCK_AUTOABORT:
+ 			s->blockState = TBLOCK_AUTOABORT_END;
+ 			break;
+ 
+ 		case TBLOCK_AUTOINPROGRESS:
+ 			s->blockState = TBLOCK_AUTOCOMMIT;
+ 			break;
+ 
+ 			/* These cases are invalid. */
+ 
+ 		default:
+ 			ereport(FATAL,
+ 					(errmsg("EndAutonomousTransactionBlock: unexpected state %s",
+ 					 BlockStateAsString(s->blockState))));
+ 			break;
+ 	}
+ 
+ 	CommitTransactionCommand();
+ 	if (preContext)
+ 		(void)MemoryContextSwitchTo(preContext);
+ 
+ 		/* if exist previous resource owner , restore it */
+ 	if (preOwner)
+ 		CurrentResourceOwner = preOwner;
+ 
+ }
+ 
+ void
+ AbortInternalAutonomousTransaction(void)
+ {
+ 
+ 	TransactionState s = CurrentTransactionState;
+ 	MemoryContext	preContext  = NULL;
+ 	ResourceOwner	preOwner    = NULL;
+ 	PLpgSQL_GetPreContextAndResource(&preContext,&preOwner);
+ 
+ 	switch (s->blockState)
+ 	{
+ 		case 	TBLOCK_AUTOBEGIN:
+ 		case 	TBLOCK_AUTOCOMMIT:
+ 		case 	TBLOCK_AUTOABORT_PENDING:
+ 		case 	TBLOCK_AUTOINPROGRESS:
+ 				AbortAutonomousTransaction();
+ 				break;
+ 
+ 		case 	TBLOCK_AUTOABORT:
+ 		case 	TBLOCK_AUTOABORT_END:
+ 				break;
+ 
+ 		default:
+ 			ereport(FATAL,
+ 				(errmsg("AbortautonomousTransactionBlock: unexpected state %s",
+ 				 BlockStateAsString(s->blockState))));
+ 	}
+ 	CleanupSubTransaction();
+ 
+ 				/* if exist previous memory context , restore it */
+ 	if (preContext)
+ 		(void)MemoryContextSwitchTo(preContext);
+ 
+ 		/* if exist previous resource owner , restore it */
+ 	if (preOwner)
+ 		CurrentResourceOwner = preOwner;
+ }
+ 
+ TransactionId GetTopAutonomousTransactionID(void)
+ {
+ 	TransactionId result = InvalidTransactionId;
+ 	TransactionState s = CurrentTransactionState;
+ 	TransactionState target;
+ 	for (target = s; PointerIsValid(target); target = target->parent)
+ 	{
+ 		 if(IS_TOP_AUTO_TX_STATE(target))
+ 		 {
+ 			if (!TransactionIdIsValid(target->transactionId))
+ 			{
+ 				AssignTransactionId(target);
+ 			}
+ 			result = target->transactionId;
+ 			return result;
+ 		 }
+ 
+ 	}
+ 	if (!TransactionIdIsValid(result))
+ 		ereport(ERROR,
+ 			(errmsg("Not in a autonomous transaction")));
+ 
+ 	return result;
+ }
+ 
+ bool IsCurrentAutoTx()
+ {
+ 	return IS_TOP_AUTO_TX_STATE(CurrentTransactionState);
+ }
+ 
+ 
*** a/src/backend/catalog/namespace.c
--- b/src/backend/catalog/namespace.c
***************
*** 3789,3794 **** AtEOSubXact_Namespace(bool isCommit, SubTransactionId mySubid,
--- 3789,3843 ----
  	}
  }
  
+ void
+ AtEOAutoXact_Namespace(bool isCommit, SubTransactionId mySubid,
+ 					  SubTransactionId parentSubid)
+ {
+ 	OverrideStackEntry *entry;
+ 
+ 	if ((myTempNamespaceSubID == mySubid) && !isCommit)
+ 	{
+ 			myTempNamespaceSubID = InvalidSubTransactionId;
+ 			/* TEMP namespace creation failed, so reset state */
+ 			myTempNamespace = InvalidOid;
+ 			myTempToastNamespace = InvalidOid;
+ 			baseSearchPathValid = false;		/* need to rebuild list */
+ 	}
+ 
+ 	/*
+ 	 * Clean up if someone failed to do PopOverrideSearchPath
+ 	 */
+ 	while (overrideStack)
+ 	{
+ 		entry = (OverrideStackEntry *) linitial(overrideStack);
+ 		if (entry->nestLevel < GetCurrentTransactionNestLevel())
+ 			break;
+ 		if (isCommit)
+ 			ereport(WARNING,
+ 				(errmsg("leaked override search path")));
+ 		overrideStack = list_delete_first(overrideStack);
+ 		list_free(entry->searchPath);
+ 		pfree(entry);
+ 	}
+ 
+ 	/* Activate the next level down. */
+ 	if (overrideStack)
+ 	{
+ 		entry = (OverrideStackEntry *) linitial(overrideStack);
+ 		activeSearchPath = entry->searchPath;
+ 		activeCreationNamespace = entry->creationNamespace;
+ 		activeTempCreationPending = false;		/* XXX is this OK? */
+ 	}
+ 	else
+ 	{
+ 		/* If not baseSearchPathValid, this is useless but harmless */
+ 		activeSearchPath = baseSearchPath;
+ 		activeCreationNamespace = baseCreationNamespace;
+ 		activeTempCreationPending = baseTempCreationPending;
+ 	}
+ }
+ 
+ 
  /*
   * Remove all relations in the specified temp namespace.
   *
*** a/src/backend/commands/sequence.c
--- b/src/backend/commands/sequence.c
***************
*** 975,981 **** open_share_lock(SeqTable seq)
  		currentOwner = CurrentResourceOwner;
  		PG_TRY();
  		{
! 			CurrentResourceOwner = TopTransactionResourceOwner;
  			LockRelationOid(seq->relid, AccessShareLock);
  		}
  		PG_CATCH();
--- 975,985 ----
  		currentOwner = CurrentResourceOwner;
  		PG_TRY();
  		{
! 			if(!MyProc->inAutoTXLevel)
! 			{
! 				CurrentResourceOwner = TopTransactionResourceOwner;
! 			}
! 
  			LockRelationOid(seq->relid, AccessShareLock);
  		}
  		PG_CATCH();
*** a/src/backend/commands/tablecmds.c
--- b/src/backend/commands/tablecmds.c
***************
*** 88,93 ****
--- 88,94 ----
  #include "utils/syscache.h"
  #include "utils/tqual.h"
  #include "utils/typcache.h"
+ #include "storage/proc.h"
  
  
  /*
***************
*** 107,112 **** typedef struct OnCommitItem
--- 108,116 ----
  	 */
  	SubTransactionId creating_subid;
  	SubTransactionId deleting_subid;
+ 
+ 	TransactionId	toptxid;	/* top tx id */
+ 
  } OnCommitItem;
  
  static List *on_commits = NIL;
***************
*** 10794,10799 **** PreCommit_on_commit_actions(void)
--- 10798,10805 ----
  				/* Do nothing (there shouldn't be such entries, actually) */
  				break;
  			case ONCOMMIT_DELETE_ROWS:
+ 				if (MyProc->inAutoTXLevel)
+ 					break;
  
  				/*
  				 * If this transaction hasn't accessed any temporary
***************
*** 10807,10812 **** PreCommit_on_commit_actions(void)
--- 10813,10821 ----
  				{
  					ObjectAddress object;
  
+ 					if (GetTopTransactionId() != oc->toptxid)
+ 						break;
+ 
  					object.classId = RelationRelationId;
  					object.objectId = oc->relid;
  					object.objectSubId = 0;
*** a/src/backend/commands/trigger.c
--- b/src/backend/commands/trigger.c
***************
*** 57,63 ****
  #include "utils/syscache.h"
  #include "utils/tqual.h"
  #include "utils/tuplestore.h"
! 
  
  /* GUC variables */
  int			SessionReplicationRole = SESSION_REPLICATION_ROLE_ORIGIN;
--- 57,63 ----
  #include "utils/syscache.h"
  #include "utils/tqual.h"
  #include "utils/tuplestore.h"
! #include "storage/proc.h"
  
  /* GUC variables */
  int			SessionReplicationRole = SESSION_REPLICATION_ROLE_ORIGIN;
***************
*** 3678,3694 **** AfterTriggerExecute(AfterTriggerEvent event,
  static bool
  afterTriggerMarkEvents(AfterTriggerEventList *events,
  					   AfterTriggerEventList *move_list,
! 					   bool immediate_only)
  {
  	bool		found = false;
  	AfterTriggerEvent event;
  	AfterTriggerEventChunk *chunk;
  
  	for_each_event_chunk(event, chunk, *events)
  	{
  		AfterTriggerShared evtshared = GetTriggerSharedData(event);
  		bool		defer_it = false;
  
  		if (!(event->ate_flags &
  			  (AFTER_TRIGGER_DONE | AFTER_TRIGGER_IN_PROGRESS)))
  		{
--- 3678,3700 ----
  static bool
  afterTriggerMarkEvents(AfterTriggerEventList *events,
  					   AfterTriggerEventList *move_list,
! 					   bool immediate_only, bool inAutoX)
  {
  	bool		found = false;
  	AfterTriggerEvent event;
  	AfterTriggerEventChunk *chunk;
+ 	int			my_level = GetCurrentTransactionNestLevel();
  
  	for_each_event_chunk(event, chunk, *events)
  	{
  		AfterTriggerShared evtshared = GetTriggerSharedData(event);
  		bool		defer_it = false;
  
+ 		if ((inAutoX) && (chunk == events->head) && ((char *)event < afterTriggers->events_stack[my_level].tailfree))
+ 		{
+ 			continue;
+ 		}
+ 
  		if (!(event->ate_flags &
  			  (AFTER_TRIGGER_DONE | AFTER_TRIGGER_IN_PROGRESS)))
  		{
***************
*** 3751,3757 **** static bool
  afterTriggerInvokeEvents(AfterTriggerEventList *events,
  						 CommandId firing_id,
  						 EState *estate,
! 						 bool delete_ok)
  {
  	bool		all_fired = true;
  	AfterTriggerEventChunk *chunk;
--- 3757,3764 ----
  afterTriggerInvokeEvents(AfterTriggerEventList *events,
  						 CommandId firing_id,
  						 EState *estate,
! 						 bool delete_ok,
! 						 bool inAutoX)
  {
  	bool		all_fired = true;
  	AfterTriggerEventChunk *chunk;
***************
*** 3763,3768 **** afterTriggerInvokeEvents(AfterTriggerEventList *events,
--- 3770,3776 ----
  	Instrumentation *instr = NULL;
  	TupleTableSlot *slot1 = NULL,
  			   *slot2 = NULL;
+ 	int			my_level = GetCurrentTransactionNestLevel();
  
  	/* Make a local EState if need be */
  	if (estate == NULL)
***************
*** 3788,3793 **** afterTriggerInvokeEvents(AfterTriggerEventList *events,
--- 3796,3805 ----
  		{
  			AfterTriggerShared evtshared = GetTriggerSharedData(event);
  
+ 			if ((inAutoX) && (chunk == events->head) && ((char *)event < afterTriggers->events_stack[my_level].tailfree))
+ 			{
+ 				continue;
+ 			}
  			/*
  			 * Is it one for me to fire?
  			 */
***************
*** 4032,4043 **** AfterTriggerEndQuery(EState *estate)
  	for (;;)
  	{
  		events = &afterTriggers->query_stack[afterTriggers->query_depth];
! 		if (afterTriggerMarkEvents(events, &afterTriggers->events, true))
  		{
  			CommandId	firing_id = afterTriggers->firing_counter++;
  
  			/* OK to delete the immediate events after processing them */
! 			if (afterTriggerInvokeEvents(events, firing_id, estate, true))
  				break;			/* all fired */
  		}
  		else
--- 4044,4055 ----
  	for (;;)
  	{
  		events = &afterTriggers->query_stack[afterTriggers->query_depth];
! 		if (afterTriggerMarkEvents(events, &afterTriggers->events, true, false))
  		{
  			CommandId	firing_id = afterTriggers->firing_counter++;
  
  			/* OK to delete the immediate events after processing them */
! 			if (afterTriggerInvokeEvents(events, firing_id, estate, true, false))
  				break;			/* all fired */
  		}
  		else
***************
*** 4096,4106 **** AfterTriggerFireDeferred(void)
  	 * Run all the remaining triggers.	Loop until they are all gone, in case
  	 * some trigger queues more for us to do.
  	 */
! 	while (afterTriggerMarkEvents(events, NULL, false))
  	{
  		CommandId	firing_id = afterTriggers->firing_counter++;
  
! 		if (afterTriggerInvokeEvents(events, firing_id, NULL, true))
  			break;				/* all fired */
  	}
  
--- 4108,4200 ----
  	 * Run all the remaining triggers.	Loop until they are all gone, in case
  	 * some trigger queues more for us to do.
  	 */
! 	while (afterTriggerMarkEvents(events, NULL, false, false))
! 	{
! 		CommandId	firing_id = afterTriggers->firing_counter++;
! 
! 		if (afterTriggerInvokeEvents(events, firing_id, NULL, true, false))
! 			break;				/* all fired */
! 	}
! 
! 	/*
! 	 * We don't bother freeing the event list, since it will go away anyway
! 	 * (and more efficiently than via pfree) in AfterTriggerEndXact.
! 	 */
! 
! 	if (snap_pushed)
! 		PopActiveSnapshot();
! }
! 
! /* ----------
!  * AfterTriggerFireDeferredForAutoX()
!  * Called when autonomous transaction commit.
!  * It is different from AfterTriggerFireDeferred that it would
!  * only check below chunks in afterTriggers->events.
!  * We can ensure it would only mark and invoke after trigger
!  * events in current autonomous transaction in this way.
!  * ------
!  */
! void
! AfterTriggerFireDeferredForAutoX(void)
! {
! 	AfterTriggerEventList *events;
! 	bool		snap_pushed = false;
! 	int			my_level = GetCurrentTransactionNestLevel();
! 	MemoryContext old_cxt;
! 	AfterTriggerEventChunk *chunk;
! 	/* Must be inside a transaction */
! 	Assert(afterTriggers != NULL);
! 
! 	/* ... but not inside a query */
! 	Assert(afterTriggers->query_depth ==
! 			   afterTriggers->depth_stack[my_level]);
! 
! 	/*
! 	 * If there are any triggers to fire, make sure we have set a snapshot for
! 	 * them to use.  (Since PortalRunUtility doesn't set a snap for COMMIT, we
! 	 * can't assume ActiveSnapshot is valid on entry.)
! 	 */
! 
! 	if (NULL != afterTriggers->events_stack[my_level].tail)
! 	{
! 		chunk = afterTriggers->events_stack[my_level].tail;
! 	}
! 	else
! 	{
! 		chunk = afterTriggers->events.head;
! 	}
! 
! 	if (afterTriggers->events.tail == NULL || afterTriggers->events_stack[my_level].tailfree == afterTriggers->events.tailfree)
! 	{
! 		return;
! 	}
! 	else
! 	{
! 		old_cxt = MemoryContextSwitchTo(TopTransactionContext);
! 
! 		events = (AfterTriggerEventList *)palloc(sizeof(AfterTriggerEventList));
! 		events->head = chunk;
! 		events->tail = afterTriggers->events.tail;
! 		events->tailfree = afterTriggers->events.tailfree;
! 
! 		(void)MemoryContextSwitchTo(old_cxt);
! 	}
! 
! 	if (events->head != NULL)
! 	{
! 		PushActiveSnapshot(GetTransactionSnapshot());
! 		snap_pushed = true;
! 	}
! 
! 	/*
! 	 * Run all the remaining triggers.	Loop until they are all gone, in case
! 	 * some trigger queues more for us to do.
! 	 */
! 	while (afterTriggerMarkEvents(events, NULL, false, true))
  	{
  		CommandId	firing_id = afterTriggers->firing_counter++;
  
! 		if (afterTriggerInvokeEvents(events, firing_id, NULL, true, true))
  			break;				/* all fired */
  	}
  
***************
*** 4111,4116 **** AfterTriggerFireDeferred(void)
--- 4205,4211 ----
  
  	if (snap_pushed)
  		PopActiveSnapshot();
+ 	pfree(events);
  }
  
  
***************
*** 4658,4664 **** AfterTriggerSetState(ConstraintsSetStmt *stmt)
  		AfterTriggerEventList *events = &afterTriggers->events;
  		bool		snapshot_set = false;
  
! 		while (afterTriggerMarkEvents(events, NULL, true))
  		{
  			CommandId	firing_id = afterTriggers->firing_counter++;
  
--- 4753,4759 ----
  		AfterTriggerEventList *events = &afterTriggers->events;
  		bool		snapshot_set = false;
  
! 		while (afterTriggerMarkEvents(events, NULL, true, false))
  		{
  			CommandId	firing_id = afterTriggers->firing_counter++;
  
***************
*** 4683,4689 **** AfterTriggerSetState(ConstraintsSetStmt *stmt)
  			 * subtransaction could later get rolled back.
  			 */
  			if (afterTriggerInvokeEvents(events, firing_id, NULL,
! 										 !IsSubTransaction()))
  				break;			/* all fired */
  		}
  
--- 4778,4784 ----
  			 * subtransaction could later get rolled back.
  			 */
  			if (afterTriggerInvokeEvents(events, firing_id, NULL,
! 										 !IsSubTransaction(), false))
  				break;			/* all fired */
  		}
  
*** a/src/backend/executor/spi.c
--- b/src/backend/executor/spi.c
***************
*** 2074,2079 **** _SPI_execute_plan(SPIPlanPtr plan, ParamListInfo paramLI,
--- 2074,2096 ----
  		 * Replan if needed, and increment plan refcount.  If it's a saved
  		 * plan, the refcount must be backed by the CurrentResourceOwner.
  		 */
+ 		if ((plansource)->raw_parse_tree &&
+ 				IsA((plansource)->raw_parse_tree, TransactionStmt))
+ 
+ 		{
+ 			if (((TransactionStmt*)(plansource->raw_parse_tree))->kind == TRANS_STMT_AUTONOMOUS)
+ 			{
+ 				BeginInternalAutonomousTransaction();
+ 				continue;
+ 			}
+ 
+ 			if (IsCurrentAutoTx())
+ 			{
+ 				CommitInternalAutonomousTransaction();
+ 				continue;
+ 			}
+ 		}
+ 
  		cplan = GetCachedPlan(plansource, paramLI, plan->saved);
  		stmt_list = cplan->stmt_list;
  
*** a/src/backend/parser/gram.y
--- b/src/backend/parser/gram.y
***************
*** 524,529 **** static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
--- 524,530 ----
  %token <keyword> ABORT_P ABSOLUTE_P ACCESS ACTION ADD_P ADMIN AFTER
  	AGGREGATE ALL ALSO ALTER ALWAYS ANALYSE ANALYZE AND ANY ARRAY AS ASC
  	ASSERTION ASSIGNMENT ASYMMETRIC AT ATTRIBUTE AUTHORIZATION
+ 	AUTONOMOUS_TRANSACTION
  
  	BACKWARD BEFORE BEGIN_P BETWEEN BIGINT BINARY BIT
  	BOOLEAN_P BOTH BY
***************
*** 575,581 **** static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);
  	ORDER ORDINALITY OUT_P OUTER_P OVER OVERLAPS OVERLAY OWNED OWNER
  
  	PARSER PARTIAL PARTITION PASSING PASSWORD PLACING PLANS POSITION
! 	PRECEDING PRECISION PRESERVE PREPARE PREPARED PRIMARY
  	PRIOR PRIVILEGES PROCEDURAL PROCEDURE PROGRAM
  
  	QUOTE
--- 576,582 ----
  	ORDER ORDINALITY OUT_P OUTER_P OVER OVERLAPS OVERLAY OWNED OWNER
  
  	PARSER PARTIAL PARTITION PASSING PASSWORD PLACING PLANS POSITION
! 	PRAGMA PRECEDING PRECISION PRESERVE PREPARE PREPARED PRIMARY
  	PRIOR PRIVILEGES PROCEDURAL PROCEDURE PROGRAM
  
  	QUOTE
***************
*** 8154,8159 **** TransactionStmt:
--- 8155,8167 ----
  					n->gid = $3;
  					$$ = (Node *)n;
  				}
+ 			| PRAGMA AUTONOMOUS_TRANSACTION
+ 				{
+                     TransactionStmt *n = makeNode(TransactionStmt);
+                     n->kind = TRANS_STMT_AUTONOMOUS;
+                     n->options = NIL;
+                     $$ = (Node *)n;
+                 }
  		;
  
  opt_transaction:	WORK							{}
***************
*** 12803,12808 **** unreserved_keyword:
--- 12811,12817 ----
  			| ASSIGNMENT
  			| AT
  			| ATTRIBUTE
+ 			| AUTONOMOUS_TRANSACTION
  			| BACKWARD
  			| BEFORE
  			| BEGIN_P
***************
*** 12946,12951 **** unreserved_keyword:
--- 12955,12961 ----
  			| PASSING
  			| PASSWORD
  			| PLANS
+ 			| PRAGMA
  			| PRECEDING
  			| PREPARE
  			| PREPARED
